# U.S. Forms System

***THIS IS A WORK IN PROGRESS.***

Modelled after the [US Web Design System](https://designsystem.digital.gov/), this project creates an open source code library and set of guiding principles for building complex web-based forms significantly faster than existing methods, using best practices in user experience and data collection, validation, and transmission.

This library enables you to build web-based forms using [React](https://reactjs.org) and the [JSON Schema standard](http://json-schema.org/). Instead of building and configuring your React components from scratch, use this library and guidance to describe the form fields in a JSON Schema configuration file, which will then render the backing React components necessary to build your form.

Originally inspired by Mozilla's [react-jsonschema-form](https://github.com/mozilla-services/react-jsonschema-form) library, we've created a version specific build web-based forms for government, styled using the [U.S. Web Design System](https://designsystem.digital.gov/) for a consistent look and feel across government.

---

We'll be documenting our roadmap, research, and process in [the wiki](https://github.com/usds/us-forms-system/wiki) as work on getting the code library ready. Feel free to look around [our wiki](https://github.com/usds/us-forms-system/wiki) and [our project board](https://github.com/orgs/usds/projects/3) if you want to follow along with our progress. That's also where developer documentation and best practices guidance for forms design and development will be found as it comes together.
