# Building a form

### [About the US Forms System library](about-the-us-forms-system-library.md)

The US Forms System lets you build web-based forms using React and the JSON Schema standard.

### [Creating a form config file](creating-a-form-config-file.md)

Your form is generated from a `form.js` file, along with a few other key configuration files.

### [Adding widgets and definitions](adding-widgets-and-definitions.md)

There are many common fields and widgets you can use to build forms. There are common types of definitions: `schema`/`uiSchema` objects and functions that return `schema`/`uiSchema` objects.

### [Common patterns for building forms](common-patterns-for-building-forms.md)

Some forms require custom validation, styles, or conditional information based on user input. Use these patterns to address those needs.

[Back to *US Forms System Documentation*](docs/README.md)
